<?php

/**
* Provides a simple "blogroll" block.
*
* Installation:     Copy into your lib-custom.php, create a new PHP block
*                   calling phpblock_blogroll
*
* Configuration:    Select a category from which the links are taken.
*                   Links can either be direct links or use Geeklog's portal.php
*                   (so that clicks are counted).
*                   Links can be in random order or sorted.
*
* Author:           Dirk Haun <dirk AT haun-online DOT de>
* License:          Released under the GNU General Public License
*
* Version:          1.1 (fixed "random" option)
*
*/
function phpblock_blogroll ()
{
    global $_CONF, $_TABLES;

    // configuration options:

    $cat = 'Apple';     // Category to take links from
    $directlink = true; // Use direct links (true) or portal.php (false)
    $random = true;     // Random order (true) or sort by $sort (false)
    $sort = 'date';     // Sort by ... e.g. 'date', 'title', 'url'

    // === you shouldn't need to change anything below this line ==============
    $retval = '';

    $result = DB_query ("SELECT lid,url,title FROM {$_TABLES['links']} WHERE category = '$cat'" . COM_getPermSql ('AND') . " ORDER BY $sort");
    $numLinks = DB_numRows ($result);

    $links = array ();
    for ($i = 0; $i < $numLinks; $i++) {
        $A = DB_fetchArray ($result);

        if ($directlink) {
            $url = $A['url'];
            $link = '<a href="' . $url . '">';
        } else {
            $url = $_CONF['site_url']
                 . COM_buildUrl ('/portal.php?what=link&amp;item=' . $A['lid']);
            $link = '<a href="' . $url . '" title="' . $A['url'] . '">';
        }
        $links[] = $link . stripslashes ($A['title']) . '</a>';
    }

    if (count ($links) > 0) {

        if ($random) {
            $min = 0;
            $max = count ($links) - 1;

            $newlist = array ();
            do {
                $r = rand ($min, $max);

                if (!empty ($links[$r])) {
                    $newlist[] = $links[$r];
                    unset ($links[$r]);
                }

                if ($r == $min) {
                    $min = $r + 1;
                } else if ($r == $max) {
                    $max = $r - 1;
                }
                if ($min == $max) {
                    if (!empty ($links[$min])) {
                        $newlist[] = $links[$min];
                    }
                    break;
                }
            }
            while ($max > $min);

            $retval = COM_makeList ($newlist, 'list-blogroll');
        } else {
            $retval = COM_makeList ($links, 'list-blogroll');
        }
    }

    return $retval;
}

?>
